Because the optimization runtime can be rather long (several minutes to 10th of minutes),  
the evolutionary optimization examples are split in two parts: 

(1) The script to run the actual optimization 

(2) A script to analyze the optimization result (suffix "b" in numbering)

!
!    Copyright (C) 2017, P. R. Wiecha, A. Arbouet, C. Girard
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!    
!!*********************************************************************
! Author: Peter Wiecha
! CEMES/CNRS 
!
! Date: July 2016
!
!*********************************************************************







!! --- routine to get full S_P^EE / S_P^BB tensor (complex)
!! --- requires pre-calculated generalized propagator CAM0 (usually called "K")
      SUBROUTINE PROPA_SP_DECAY( &
                    & STEP,NMAX,XM,YM,ZM, N1,N2,N3, &
                    & ALAMBDA, &
                    & NPTSIN, XMAP,YMAP,ZMAP, &
                    & MAGNETIC, &
                    & CAM0, ALPHA, SP)
!                     & NTHREADS, &
      
      !f2py threadsafe
      !$ use OMP_LIB
!       use OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none


!**********************************************************************
!*      CONFIGURATION
!**********************************************************************
      ! Fixed allocations
      real(dp), parameter :: Pi=3.141592654_dp
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
      
      !***************************************
      !*      Structure properties  
      !***************************************
      !!! ATTENTION: Structure must be shifted to    Z(min) >= 0.5*step !!!
      real(dp), intent(in) :: STEP
      real(dp) :: VCELL
      
      integer, intent(in) :: NMAX
      real(dp), intent(in) :: XM(NMAX), YM(NMAX), ZM(NMAX)
      real(dp), intent(in) :: N1,N2,N3    ! RefIndex: SUBSTRATE(1), STRUCTURE SOURROUNDING(2), TOP MEDIUM(3)
      complex(dp), intent(in) :: ALPHA
      complex(dp) :: CN1,CN2,CN3
      
      
      !***************************************
      !*      Simulation
      !***************************************
!       integer, intent(in) :: NTHREADS
      
      ! wavelength (nm)
      real(dp), intent(in)  :: ALAMBDA
      real(dp)  :: AK0
      
      ! simulation type, 1=gamma_m, else=gamma_e
      integer, intent(in)  :: MAGNETIC
      
      
      !***************************************
      !*      NF-"Carte" Definition
      !***************************************
      integer, intent(in) :: NPTSIN
      real(dp), intent(in)    :: XMAP(NPTSIN),YMAP(NPTSIN),ZMAP(NPTSIN)
      
      
      
      !***************************************
      !*      Propagators
      !***************************************
      complex(dp), intent(in) :: CAM0(3*NMAX, 3*NMAX)
      complex(dp), intent(out) :: SP(NPTSIN, 9)

      
      
      
      
      !***************************************
      !*      OTHER DECLARATIONS
      !***************************************
!       integer :: NTHREADSUSE
      
      !* ----------- Temporary Propagators
      complex(dp) :: Q0XX,Q0YY,Q0ZZ, Q0XY,Q0YX,Q0XZ, Q0ZX,Q0YZ,Q0ZY
      complex(dp) :: S0XX,S0YY,S0ZZ, S0XY,S0YX,S0XZ, S0ZX,S0YZ,S0ZY
      complex(dp) :: KijXX,KijYY,KijZZ, KijXY,KijYX,KijXZ, KijZX,KijYZ,KijZY
      complex(dp) :: StmpXX,StmpYY,StmpZZ, StmpXY,StmpYX,StmpXZ, StmpZX,StmpYZ,StmpZY
      complex(dp) :: SPXX,SPYY,SPZZ, SPXY,SPYX,SPXZ, SPZX,SPYZ,SPZY
      
      real(dp) :: XObs,YObs,ZObs,  Xi,Yi,Zi,  Xj,Yj,Zj
      real(dp) :: XD,YD,ZD, XDDD,YDDD,ZDDD, SBB, SHORTER
      
      integer :: I,J, IMAP, INSIDE
      
      
      
      
      
!**********************************************************************
!*      Configure
!**********************************************************************
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)
      
      VCELL = STEP**3
!* Sourrounding refindex
      CN1 = CUN*N1
      CN2 = CUN*N2
      CN3 = CUN*N3
      
!* Wavelength/Polarization
      AK0=2._dp*Pi/ALAMBDA
      
      
      !* --- Loop Cartography-points 
!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(ALAMBDA,AK0, VCELL, CN1,CN2,CN3), &
!$OMP& SHARED(NMAX, NPTSIN, MAGNETIC), &
!$OMP& SHARED(XM,YM,ZM, XMAP,YMAP,ZMAP), &
!$OMP& SHARED(SP, CAM0)
!$OMP DO
      DO IMAP=1,NPTSIN
        XObs = XMAP(IMAP)
        YObs = YMAP(IMAP)
        ZObs = ZMAP(IMAP)
        
        !* --- initialize final matrix SP
        SP(IMAP, 1) = C0
        SP(IMAP, 2) = C0
        SP(IMAP, 3) = C0
        SP(IMAP, 4) = C0
        SP(IMAP, 5) = C0
        SP(IMAP, 6) = C0
        SP(IMAP, 7) = C0
        SP(IMAP, 8) = C0
        SP(IMAP, 9) = C0
        
        !* --- Check if inside or outside of structure
        SBB=STEP*0.999
      INSIDE = 0
      DO J=1,NMAX
        XD = XM(J)
        YD = YM(J)
        ZD = ZM(J)
        XDDD = XObs-XD
        YDDD = YObs-YD
        ZDDD = ZObs-ZD
        SHORTER=SQRT(XDDD**2+YDDD**2+ZDDD**2) 
        IF (SHORTER.LE.SBB) THEN
            !* --- inside structure: get closest meshpoint
            SBB=SHORTER
            INSIDE = J
        ENDIF
      ENDDO        
        
!!!*** =======================================
!!!*** INSIDE STRUCTURE
!!!*** =======================================
        IF (INSIDE /= 0) THEN
            !* --- take simply the diagonal tensor on generalized propagator for cell "inside"
            I = INSIDE
            J = INSIDE
            IF (MAGNETIC==1) THEN
                SP(IMAP, 1) = 0
                SP(IMAP, 4) = 0
                SP(IMAP, 7) = 0
                
                SP(IMAP, 2) = 0
                SP(IMAP, 5) = 0
                SP(IMAP, 8) = 0
                
                SP(IMAP, 3) = 0
                SP(IMAP, 6) = 0
                SP(IMAP, 9) = 0
            ELSE
                SP(IMAP, 1) = (CAM0(3*(I-1)+1, 3*(J-1)+1) - 1) / alpha
                SP(IMAP, 4) = CAM0(3*(I-1)+2, 3*(J-1)+1) / alpha
                SP(IMAP, 7) = CAM0(3*(I-1)+3, 3*(J-1)+1) / alpha
                
                SP(IMAP, 2) = CAM0(3*(I-1)+1, 3*(J-1)+2) / alpha
                SP(IMAP, 5) = (CAM0(3*(I-1)+2, 3*(J-1)+2) - 1) / alpha
                SP(IMAP, 8) = CAM0(3*(I-1)+3, 3*(J-1)+2) / alpha
                
                SP(IMAP, 3) = CAM0(3*(I-1)+1, 3*(J-1)+3) / alpha
                SP(IMAP, 6) = CAM0(3*(I-1)+2, 3*(J-1)+3) / alpha
                SP(IMAP, 9) = (CAM0(3*(I-1)+3, 3*(J-1)+3) - 1) / alpha
            ENDIF
            
!!!*** =======================================
!!!*** OUTSIDE STRUCTURE
!!!*** =======================================
        ELSEIF (INSIDE == 0) THEN
        !* --- Double-integral over structure
        DO I=1,NMAX
          Xi = XM(I)
          Yi = YM(I)
          Zi = ZM(I)
          DO J=1,NMAX
            Xj = XM(J)
            Yj = YM(J)
            Zj = ZM(J)
!! ELECMAG0_FULL: B-dipole; MAGMAG0_FULL: E-dipole
            IF (MAGNETIC==1) THEN
              CALL ELECMAG0_FULL(AK0, XObs,YObs,ZObs, Xi,Yi,Zi, &
                            & Q0XX, Q0XY, Q0XZ, &
                            & Q0YX, Q0YY, Q0YZ, &
                            & Q0ZX, Q0ZY, Q0ZZ, &
                            & cn1,cn2,cn3)
              Q0XX = -1*Q0XX
              Q0XY = -1*Q0XY
              Q0XZ = -1*Q0XZ
              Q0YX = -1*Q0YX
              Q0YY = -1*Q0YY
              Q0YZ = -1*Q0YZ
              Q0ZX = -1*Q0ZX
              Q0ZY = -1*Q0ZY
              Q0ZZ = -1*Q0ZZ
              CALL ELECMAG0_FULL(AK0, Xj,Yj,Zj, XObs,YObs,ZObs, &
                            & S0XX, S0XY, S0XZ, &
                            & S0YX, S0YY, S0YZ, &
                            & S0ZX, S0ZY, S0ZZ, &
                            & cn1,cn2,cn3)
            ELSE
              CALL MAGMAG0_FULL(AK0, XObs,YObs,ZObs, Xi,Yi,Zi, &
                            & Q0XX, Q0XY, Q0XZ, &
                            & Q0YX, Q0YY, Q0YZ, &
                            & Q0ZX, Q0ZY, Q0ZZ, &
                            & cn1,cn2,cn3)
              CALL MAGMAG0_FULL(AK0, Xj,Yj,Zj, XObs,YObs,ZObs, &
                            & S0XX, S0XY, S0XZ, &
                            & S0YX, S0YY, S0YZ, &
                            & S0ZX, S0ZY, S0ZZ, &
                            & cn1,cn2,cn3)
            ENDIF
            
            KijXX = CAM0(3*(I-1)+1, 3*(J-1)+1)
            KijYX = CAM0(3*(I-1)+2, 3*(J-1)+1)
            KijZX = CAM0(3*(I-1)+3, 3*(J-1)+1)
            KijXY = CAM0(3*(I-1)+1, 3*(J-1)+2)
            KijYY = CAM0(3*(I-1)+2, 3*(J-1)+2)
            KijZY = CAM0(3*(I-1)+3, 3*(J-1)+2)
            KijXZ = CAM0(3*(I-1)+1, 3*(J-1)+3)
            KijYZ = CAM0(3*(I-1)+2, 3*(J-1)+3)
            KijZZ = CAM0(3*(I-1)+3, 3*(J-1)+3)
            
            
            !* --- Calculate Stmp = K.S0
            StmpXX = KijXX*S0XX + KijXY*S0YX + KijXZ*S0ZX
            StmpXY = KijXX*S0XY + KijXY*S0YY + KijXZ*S0ZY
            StmpXZ = KijXX*S0XZ + KijXY*S0YZ + KijXZ*S0ZZ
            
            StmpYX = KijYX*S0XX + KijYY*S0YX + KijYZ*S0ZX
            StmpYY = KijYX*S0XY + KijYY*S0YY + KijYZ*S0ZY
            StmpYZ = KijYX*S0XZ + KijYY*S0YZ + KijYZ*S0ZZ
            
            StmpZX = KijZX*S0XX + KijZY*S0YX + KijZZ*S0ZX
            StmpZY = KijZX*S0XY + KijZY*S0YY + KijZZ*S0ZY
            StmpZZ = KijZX*S0XZ + KijZY*S0YZ + KijZZ*S0ZZ
            
            
            !* --- Calculate SP = Q0.Stmp
            SPXX = Q0XX*StmpXX + Q0XY*StmpYX + Q0XZ*StmpZX
            SPXY = Q0XX*StmpXY + Q0XY*StmpYY + Q0XZ*StmpZY
            SPXZ = Q0XX*StmpXZ + Q0XY*StmpYZ + Q0XZ*StmpZZ
            
            SPYX = Q0YX*StmpXX + Q0YY*StmpYX + Q0YZ*StmpZX
            SPYY = Q0YX*StmpXY + Q0YY*StmpYY + Q0YZ*StmpZY
            SPYZ = Q0YX*StmpXZ + Q0YY*StmpYZ + Q0YZ*StmpZZ
            
            SPZX = Q0ZX*StmpXX + Q0ZY*StmpYX + Q0ZZ*StmpZX
            SPZY = Q0ZX*StmpXY + Q0ZY*StmpYY + Q0ZZ*StmpZY
            SPZZ = Q0ZX*StmpXZ + Q0ZY*StmpYZ + Q0ZZ*StmpZZ
            
            
            !* --- construct final matrix
            SP(IMAP, 1) = SP(IMAP, 1) + SPXX
            SP(IMAP, 2) = SP(IMAP, 2) + SPXY
            SP(IMAP, 3) = SP(IMAP, 3) + SPXZ
            SP(IMAP, 4) = SP(IMAP, 4) + SPYX
            SP(IMAP, 5) = SP(IMAP, 5) + SPYY
            SP(IMAP, 6) = SP(IMAP, 6) + SPYZ
            SP(IMAP, 7) = SP(IMAP, 7) + SPZX
            SP(IMAP, 8) = SP(IMAP, 8) + SPZY
            SP(IMAP, 9) = SP(IMAP, 9) + SPZZ
            
          ENDDO
        ENDDO
!         write (*,*) "outside:", SP(IMAP,1)
        ENDIF
        
        !* --- normalization
        SP(IMAP, 1) = SP(IMAP, 1) * VCELL
        SP(IMAP, 2) = SP(IMAP, 2) * VCELL
        SP(IMAP, 3) = SP(IMAP, 3) * VCELL
        SP(IMAP, 4) = SP(IMAP, 4) * VCELL
        SP(IMAP, 5) = SP(IMAP, 5) * VCELL
        SP(IMAP, 6) = SP(IMAP, 6) * VCELL
        SP(IMAP, 7) = SP(IMAP, 7) * VCELL
        SP(IMAP, 8) = SP(IMAP, 8) * VCELL
        SP(IMAP, 9) = SP(IMAP, 9) * VCELL
      ENDDO
!$OMP END DO
!$OMP END PARALLEL 

      END

    MODULE PYGDMPRECISION
! Define precision of variables
!if you want to run in single-precision set  DP=KIND(0.E0)
      INTEGER,PARAMETER :: DP=KIND(0.E0)

!if you want to run in double-precision set  DP=KIND(0.D0)
!       INTEGER,PARAMETER :: DP=KIND(0.D0)

    END MODULE PYGDMPRECISION

!
!    Copyright (C) 2017, P. R. Wiecha, A. Arbouet, C. Girard
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!    
!
!
!################################################################################
!################################################################################
!
!   -------- SUBROUTINE: EXTINCT -------- 
!            Calculate Extinction/Absorption Cross-Sections
!
!################################################################################
!################################################################################

!**********************************************************************
!*
!* original code from C. Girard / A.Arbouet CEMES Toulouse
!*
!* edited as python module by P. Wiecha, CEMES, 2015-2016
!*
!**********************************************************************

      SUBROUTINE EXTINCT(ELAMBDA, &
                        & CAP, &
                        & CN2, &
                        & CEX,CEY, CEZ,&
                        & CEX0,CEY0,CEZ0, &
                        & NLAMB, &
                        & NMAX, &
                        & AEXT, AABS)
!                         NTHREADS, &
      
      !f2py threadsafe
      !$ use OMP_LIB
!       use OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
!**********************************************************************
!*      CONFIGURATION
!**********************************************************************
      ! Fixed allocations
      real(dp), parameter :: Pi=3.141592654_dp
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
      
      !***************************************
      !*      Structure properties  
      !***************************************
      !!! ATTENTION: Structure must be shifted to    Z(min) >= 0.5*step !!!
      integer, intent(in) :: NMAX
      complex(dp), intent(in) :: CN2    ! RefIndex: STRUCTURE SOURROUNDING(2)
      complex(dp), intent(in) :: CAP(NMAX,NLAMB) ! complex polarizabilities of meshpoints for each wavelength
      complex(dp), intent(in) :: CEX(NMAX,NLAMB), CEY(NMAX,NLAMB), CEZ(NMAX,NLAMB) ! self-consistent field inside structure
      
      ! Incident E-field (zero order)
      complex(dp), intent(in) :: CEX0(NMAX,NLAMB),CEY0(NMAX,NLAMB),CEZ0(NMAX,NLAMB)
      
      !***************************************
      !*      Simulation
      !***************************************
!       integer, intent(in) :: NTHREADS
      
      ! Number and range of wavelengths (nm)
      integer, intent(in) :: NLAMB
      real(dp), intent(in)  :: ELAMBDA(NLAMB)
      
      
!**********************************************************************
!*      DECLARATION
!**********************************************************************
!       integer :: NTHREADSUSE
      real(dp) :: ALAMBDA,AK0
      
      complex(dp) :: CCEX0,CCEY0,CCEZ0
      
      integer :: I, ILAMB

      complex(dp) :: CCEX(NMAX,NLAMB), CCEY(NMAX,NLAMB), CCEZ(NMAX,NLAMB)
      complex(dp) :: CPPX(NMAX,NLAMB), CPPY(NMAX,NLAMB), CPPZ(NMAX,NLAMB)
      
      complex(dp) :: CEXT(NLAMB), CABSPT(NLAMB)
      real(dp), intent(out) :: AEXT(NLAMB), AABS(NLAMB)
      
      
      complex(dp) :: CAXX(NMAX),CAYY(NMAX),CAZY(NMAX)
      complex(dp) :: CAZZ(NMAX),CAXY(NMAX),CAXZ(NMAX)
      complex(dp) :: CAYX(NMAX),CAYZ(NMAX),CAZX(NMAX)
      

!**********************************************************************
!*      INIT OPENMP
!**********************************************************************
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)


!**********************************************************************
!*      Calculate Extinction Cross-Section
!**********************************************************************
!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(ELAMBDA), &
!$OMP& SHARED(CEX,CEY,CEZ, CCEX,CCEY,CCEZ), &
!$OMP& SHARED(CEX0,CEY0,CEZ0), &
!$OMP& SHARED(CPPX,CPPY,CPPZ, AEXT,AABS, CEXT,CABSPT, CAP)
!$OMP DO
        
      !P! ------- Iterate over all wavelengths - MAIN LOOP -------
      DO ILAMB=1,NLAMB
        ALAMBDA = ELAMBDA(ILAMB)
        
        !P! Wavenumber
        AK0 = 2._dp*Pi/ALAMBDA
        !! Init Arrays
        DO I=1,NMAX
            ! Complex Conjugate Efield
            CCEX(I,ILAMB) = CONJG(CEX(I,ILAMB))
            CCEY(I,ILAMB) = CONJG(CEY(I,ILAMB))
            CCEZ(I,ILAMB) = CONJG(CEZ(I,ILAMB))
        ENDDO
        
        ! Init Cross sections
        CEXT(ILAMB)=C0
        CABSPT(ILAMB)=C0
        AEXT(ILAMB)=0_dp
        AABS(ILAMB)=0_dp

        
!-----(1) Definition of the anisotropic polarizability of each -------
!---------------------discretized  cell ------------------------------
      DO I=1,NMAX
        CAXX(I)=CAP(I,ILAMB)
        CAYY(I)=CAP(I,ILAMB)
        CAZZ(I)=CAP(I,ILAMB)
        CAXY(I)=C0
        CAYX(I)=C0
        CAXZ(I)=C0
        CAZX(I)=C0
        CAZY(I)=C0
        CAYZ(I)=C0
      ENDDO
      

!------- (2) Building the vector Alpha.Eself -------------------------
!------------- (polarization at each meshpoint) ----------------------
      DO I=1,NMAX
        CPPX(I,ILAMB)=CAXX(I)*CEX(I,ILAMB) + CAXY(I)*CEY(I,ILAMB) + CAXZ(I)*CEZ(I,ILAMB)
        CPPY(I,ILAMB)=CAYX(I)*CEX(I,ILAMB) + CAYY(I)*CEY(I,ILAMB) + CAYZ(I)*CEZ(I,ILAMB)
        CPPZ(I,ILAMB)=CAZX(I)*CEX(I,ILAMB) + CAZY(I)*CEY(I,ILAMB) + CAZZ(I)*CEZ(I,ILAMB)
      ENDDO
        
        
        DO I=1,NMAX
            ! complex conjuguate of incident field
            CCEX0 = CONJG(CEX0(I,ILAMB))
            CCEY0 = CONJG(CEY0(I,ILAMB))
            CCEZ0 = CONJG(CEZ0(I,ILAMB))
            
            CEXT(ILAMB)=CEXT(ILAMB) &
                    & + (8._dp/ALAMBDA)/cn2*Pi**2*(CCEX0*CPPX(I,ILAMB) &
                    & + CCEY0*CPPY(I,ILAMB) + CCEZ0*CPPZ(I,ILAMB))
                    
            CABSPT(ILAMB)= CABSPT(ILAMB) &
                    & + (8._dp/ALAMBDA)/cn2*Pi**2 * AIMAG(CAP(I,ILAMB))* &
                    &  (   CEX(I,ILAMB)*CCEX(I,ILAMB) &
                    &    + CEY(I,ILAMB)*CCEY(I,ILAMB) &
                    &    + CEZ(I,ILAMB)*CCEZ(I,ILAMB))
        ENDDO
        AEXT(ILAMB) = AIMAG(CEXT(ILAMB)) 
        AABS(ILAMB) = REAL(CABSPT(ILAMB))      
      !P! -------------END MAIN LOOP - wavelengths ---------------
      ENDDO
      
!$OMP END DO      
!$OMP END PARALLEL 
      
      END SUBROUTINE EXTINCT








      
      
      
      
      
      
!################################################################################
!################################################################################
!
!   -------- SUBROUTINE: NEARFIELD -------- 
!            Nearfield outside structure at specific coordinates
!
!################################################################################
!################################################################################

!**********************************************************************
!*
!* original code from C. Girard CEMES Toulouse
!*
!* - edited for arbitrary coordinates, P. Wiecha, CEMES, 2015
!* - adapted for f2py, P. Wiecha, CEMES, 2015
!* - added routine for inner-particle fields, P. Wiecha, CEMES, 2015
!* - adapted for arbitrary/mixed materials, P. Wiecha, CEMES, 2016
!* - adapted as module for pyGDM2, P. Wiecha, CEMES, 2016
!*
!**********************************************************************

      SUBROUTINE NEARFIELD(ALAMBDA, SPACE, &
                    & STEP, &
                    & XM,YM,ZM, &
                    & CAP, &
                    & CN1,CN2,CN3, &
                    & CSOLX,CSOLY,CSOLZ, &
                    & CSOLBX,CSOLBY,CSOLBZ, &
                    & CEX,CEY,CEZ, &
                    & XMAP,YMAP,ZMAP, &
                    & FILLINSIDE, &
                    & NMAX, NPTSIN, &
                    & CEPX,CEPY,CEPZ,CEPX1,CEPY1,CEPZ1, &
                    & CBPX,CBPY,CBPZ,CBPX1,CBPY1,CBPZ1)
!                     & NTHREADS, 
      
      !f2py threadsafe
      !$ use OMP_LIB
!       use OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none


!**********************************************************************
!*      CONFIGURATION
!**********************************************************************
      ! Fixed allocations
      real(dp), parameter :: Pi=3.141592654_dp
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
      
      !***************************************
      !*      Structure  
      !***************************************
      !!! ATTENTION: Structure must be shifted to    Z(min) >= 0.5*step !!!
      real(dp), intent(in) :: STEP
      integer, intent(in) :: NMAX
      real(dp), intent(in) :: XM(NMAX), YM(NMAX), ZM(NMAX)
      complex(dp), intent(in) :: CAP(NMAX) ! polarizabilities
      real(dp), intent(in) :: SPACE  ! distance between substrate and top medium (nm)
      complex(dp), intent(in) :: CN1,CN2,CN3   ! RefIndex: substrate(1), environment around structure(2), top medium(3)
      
      ! self-consistent E-field inside structure
      complex(dp), intent(in) :: CEX(NMAX),CEY(NMAX),CEZ(NMAX)
      
      !***************************************
      !*      Simulation
      !***************************************
!       integer, intent(in) :: NTHREADS
      
      ! wavelength
      real(dp), intent(in) :: ALAMBDA

      ! Incident field (zero order)
      complex(dp), intent(in) :: CSOLX(NPTSIN),CSOLY(NPTSIN),CSOLZ(NPTSIN)
      complex(dp), intent(in) :: CSOLBX(NPTSIN),CSOLBY(NPTSIN),CSOLBZ(NPTSIN)
      
      integer, intent(in) :: FILLINSIDE

      !***************************************
      !*      NF-positions definition
      !***************************************
      integer, intent(in) :: NPTSIN
      real(dp), intent(in)    :: XMAP(NPTSIN),YMAP(NPTSIN),ZMAP(NPTSIN)

      !***************************************
      !*      NF output
      !***************************************
      complex(dp), intent(out) :: CEPX(NPTSIN),CEPY(NPTSIN),CEPZ(NPTSIN)
      complex(dp), intent(out) :: CEPX1(NPTSIN),CEPY1(NPTSIN),CEPZ1(NPTSIN)
      
      complex(dp), intent(out) :: CBPX(NPTSIN),CBPY(NPTSIN),CBPZ(NPTSIN)
      complex(dp), intent(out) :: CBPX1(NPTSIN),CBPY1(NPTSIN),CBPZ1(NPTSIN)


!* ----------- DECLARATIONS
!       integer :: NTHREADSUSE
      integer :: I,J,K
      integer :: ISCAN1,INI
      integer :: INSIDE

      complex(dp) :: CAXX(NMAX),CAYY(NMAX),CAZZ(NMAX)
      complex(dp) :: CAXY(NMAX),CAXZ(NMAX),CAYX(NMAX)
      complex(dp) :: CAYZ(NMAX),CAZX(NMAX),CAZY(NMAX)
      complex(dp) :: CFX(NMAX),CFY(NMAX),CFZ(NMAX)
      
      
      real(dp) :: SBB,SHORTER
      real(dp) :: AK0
      real(dp) :: XOBS,YOBS,ZOBS
      real(dp) :: XD,YD,ZD,XDDD,YDDD,ZDDD
      complex(dp) :: CEBXX,CEBXY,CEBXZ,CEBYY,CEBYZ,CEBZZ,CEBYX,CEBZX,CEBZY
      complex(dp) :: CTXX,CTXY,CTXZ,CTYY,CTYZ,CTZZ,CTYX,CTZX,CTZY
      real(dp) :: TXX1,TXY1,TXZ1,TYY1,TYZ1,TZZ1,TYX1,TZX1,TZY1
      real(dp) :: TXX2,TXY2,TXZ2,TYY2,TYZ2,TZZ2,TYX2,TZX2,TZY2
      real(dp) :: EBXY1,EBXZ1,EBYZ1,EBXY2,EBXZ2,EBYZ2

      

!**********************************************************************
!*      INIT
!**********************************************************************
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)
      
      
!* Wavenumber
      AK0=2._dp*Pi/ALAMBDA
      
      
        CTXX=C0
        CTYY=C0
        CTZZ=C0
        CTXY=C0
        CTXZ=C0
        CTYZ=C0
        CTYX=C0
        CTZX=C0
        CTZY=C0
        CEBXX=C0
        CEBYY=C0
        CEBZZ=C0
        CEBXY=C0
        CEBYX=C0
        CEBXZ=C0
        CEBZX=C0
        CEBYZ=C0
        CEBZY=C0


!------------GENERATION OF THE FIELD OUTSIDE THE STRUCTURE------------
!
!-----(1) Definition of the anisotropic polarizability of each -------
!---------------------discretized  cell ------------------------------
      DO I=1,NMAX
        CAXX(I)=CAP(I)
        CAYY(I)=CAP(I)
        CAZZ(I)=CAP(I)
        CAXY(I)=C0
        CAYX(I)=C0
        CAXZ(I)=C0
        CAZX(I)=C0
        CAZY(I)=C0
        CAYZ(I)=C0
      ENDDO
      

!------- (2) Building the vector Alpha.Eself -------------------------
!------------- (polarization at each meshpoint) ----------------------
      DO K=1,NMAX
        CFX(K)=CAXX(K)*CEX(K) + CAXY(K)*CEY(K) + CAXZ(K)*CEZ(K)
        CFY(K)=CAYX(K)*CEX(K) + CAYY(K)*CEY(K) + CAYZ(K)*CEZ(K)
        CFZ(K)=CAZX(K)*CEX(K) + CAZY(K)*CEY(K) + CAZZ(K)*CEZ(K)
      ENDDO


!----------------Initialization of the vectors S*Alpha*Eself ---------
!--------------------------and E0+S*Alpha*Eself--------------------------
    DO INI=1,NPTSIN
    
    !-----Will contain S*Alpha*Eself--------------------------------------
    !-----This contribution is sometimes called the ----------------
    !-----scattered field -----------------------------------------------------
        CEPX(INI) = C0
        CEPY(INI) = C0
        CEPZ(INI) = C0
        CBPX(INI) = C0
        CBPY(INI) = C0
        CBPZ(INI) = C0
        
    !-----Will contain E0+S*Alpha*Eself-----------------------------------
    !-----This vector represents the actual field existing -----------
    !-----near around the structure ----------------------------------------
        CEPX1(INI) = C0
        CEPY1(INI) = C0
        CEPZ1(INI) = C0
        CBPX1(INI) = C0
        CBPY1(INI) = C0
        CBPZ1(INI) = C0
    ENDDO 
     

!**********************************************************************
!*      Calculate Nearfield at each defined Position
!**********************************************************************
!$OMP PARALLEL DEFAULT(FIRSTPRIVATE) SHARED(ALAMBDA,AK0), &
!$OMP& SHARED(XM,YM,ZM, XMAP,YMAP,ZMAP), &
!$OMP& SHARED(CEPX,CEPY,CEPZ,CBPX,CBPY,CBPZ), &
!$OMP& SHARED(CEPX1,CEPY1,CEPZ1,CBPX1,CBPY1,CBPZ1)
!$OMP DO

    DO ISCAN1=1,NPTSIN
      XOBS=XMAP(ISCAN1)
      YOBS=YMAP(ISCAN1)
      ZOBS=ZMAP(ISCAN1)
      SBB=STEP*1.05
      INSIDE = 0
!-----Summation on all the dicretization cells------------------------
      DO J=1,NMAX
        XD=XM(J)
        YD=YM(J)
        ZD=ZM(J)
        XDDD=XOBS-XD
        YDDD=YOBS-YD
        ZDDD=ZOBS-ZD
        SHORTER=SQRT(XDDD**2+YDDD**2+ZDDD**2) 
        IF (SHORTER.LE.SBB) THEN
            SBB=SHORTER
            INSIDE = J
            CTXX=C0
            CTYY=C0
            CTZZ=C0
            CTXY=C0
            CTXZ=C0
            CTYZ=C0
            CTYX=C0
            CTZX=C0
            CTZY=C0
            CEBXX=C0
            CEBYY=C0
            CEBZZ=C0
            CEBXY=C0
            CEBYX=C0
            CEBXZ=C0
            CEBZX=C0
            CEBYZ=C0
            CEBZY=C0
        ELSEIF ((SHORTER.GT.SBB).and.(INSIDE == 0)) then
            CALL ELECMAG0(AK0,XDDD,YDDD,ZDDD,EBXY1,EBXZ1,EBYZ1,&
	        & EBXY2,EBXZ2,EBYZ2, CN1,CN2,CN3)
            CALL PROPAGATOR123(ALAMBDA,XD,YD,ZD,&
	            & XOBS,YOBS,ZOBS,SPACE,&
	            & CTXX,CTXY,CTXZ,CTYX,CTYY,CTYZ,CTZX,CTZY,CTZZ, &
	            & CN1,CN2,CN3)
! 	    
!             CTXX=TXX1*CUN+TXX2*CIM
!             CTYY=TYY1*CUN+TYY2*CIM
!             CTZZ=TZZ1*CUN+TZZ2*CIM
!             CTXY=TXY1*CUN+TXY2*CIM
!             CTXZ=TXZ1*CUN+TXZ2*CIM
!             CTYZ=TYZ1*CUN+TYZ2*CIM
!             CTYX=TYX1*CUN+TYX2*CIM
!             CTZX=TZX1*CUN+TZX2*CIM
!             CTZY=TZY1*CUN+TZY2*CIM
        !-----------------------------------------------------------------------
            CEBXX=C0
            CEBYY=C0
            CEBZZ=C0
!             CEBXY=-1*(EBXY1*CUN+EBXY2*CIM)
            CEBXY=(EBXY1*CUN+EBXY2*CIM)
            CEBYX=-CEBXY
!             CEBXZ=-1*(EBXZ1*CUN+EBXZ2*CIM)
            CEBXZ=(EBXZ1*CUN+EBXZ2*CIM)
            CEBZX=-CEBXZ
!             CEBYZ=-1*(EBYZ1*CUN+EBYZ2*CIM)
            CEBYZ=(EBYZ1*CUN+EBYZ2*CIM)
            CEBZY=-CEBYZ
        ENDIF
        if (INSIDE == 0) then
        !------ Outside structure, propagate field -------------
        !------ Cell-volume (for integration) is taken into 
        !------ account in the polarizability CF_I
            CEPX(ISCAN1)=CEPX(ISCAN1)&
                            & + CTXX*CFX(J)+CTXY*CFY(J)&
                            & + CTXZ*CFZ(J)
            CEPY(ISCAN1)=CEPY(ISCAN1)&
                            & + CTYX*CFX(J)+CTYY*CFY(J)&
                            & + CTYZ*CFZ(J)
            CEPZ(ISCAN1)=CEPZ(ISCAN1)&
                            & + CTZX*CFX(J)+CTZY*CFY(J)&
                            & + CTZZ*CFZ(J)
        !----------------------------------------------------------------------
            CBPX(ISCAN1)=CBPX(ISCAN1)&
                            & + CEBXX*CFX(J)+CEBXY*CFY(J)&
                            & + CEBXZ*CFZ(J)
            CBPY(ISCAN1)=CBPY(ISCAN1)&
                            & + CEBYX*CFX(J)+CEBYY*CFY(J)&
                            & + CEBYZ*CFZ(J)
            CBPZ(ISCAN1)=CBPZ(ISCAN1)&
                            & + CEBZX*CFX(J)+CEBZY*CFY(J)&
                            & + CEBZZ*CFZ(J)
         endif
      ENDDO
      
     
      if (INSIDE /= 0) then
!       write(*,*), " --> in", CEX(INSIDE),CEY(INSIDE)
      !------ Inside structure, take E-field at closest meshpoint, having index "INSIDE" -------------
      !-- if 0: return internal fields as zeros 
      !-- if -1: return internal fields
      !-- if -2: return internal fields as "-99999999999"
      
      !-------- the magnetic field inside the structure cannot be obtained 
      !-------- using the propagator for the self-consistent field and must 
      !-------- be calculated differently (e.g. using the corresponding 
      !-------- Greens function for the self-consistent scattering problem, or 
      !-------- by explicitly calculating the curl using numerical differentiation)
        if (FILLINSIDE == -1) then
            CEPX(ISCAN1)=CEX(INSIDE)
            CEPY(ISCAN1)=CEY(INSIDE)
            CEPZ(ISCAN1)=CEZ(INSIDE)
            CBPX(ISCAN1)=C0
            CBPY(ISCAN1)=C0
            CBPZ(ISCAN1)=C0
        elseif  (FILLINSIDE == 0) then
            CEPX(ISCAN1)=C0
            CEPY(ISCAN1)=C0
            CEPZ(ISCAN1)=C0
            CBPX(ISCAN1)=C0
            CBPY(ISCAN1)=C0
            CBPZ(ISCAN1)=C0
        elseif  (FILLINSIDE == -2) then
            CEPX(ISCAN1)=-999999
            CEPY(ISCAN1)=-999999
            CEPZ(ISCAN1)=-999999
            CBPX(ISCAN1)=-999999
            CBPY(ISCAN1)=-999999
            CBPZ(ISCAN1)=-999999
        endif
      ! --- copy as 'total' field
      CEPX1(ISCAN1) = CEPX(ISCAN1)
      CEPY1(ISCAN1) = CEPY(ISCAN1)
      CEPZ1(ISCAN1) = CEPZ(ISCAN1)
      CBPX1(ISCAN1) = CBPX(ISCAN1)
      CBPY1(ISCAN1) = CBPY(ISCAN1)
      CBPZ1(ISCAN1) = CBPZ(ISCAN1)
      
      else
      ! --- 'total' field outside:
      !* ---------------------------------------------------
      !* ---- E-field with fundamental field ----
      !* ---------------------------------------------------  
      CEPX1(ISCAN1) = CEPX(ISCAN1) + CSOLX(ISCAN1)
      CEPY1(ISCAN1) = CEPY(ISCAN1) + CSOLY(ISCAN1)
      CEPZ1(ISCAN1) = CEPZ(ISCAN1) + CSOLZ(ISCAN1)

      !* ---------------------------------------------------
      !* ---- B-field with fundamental field ----
      !* ---------------------------------------------------  
      CBPX1(ISCAN1) = CBPX(ISCAN1) + CSOLBX(ISCAN1)
      CBPY1(ISCAN1) = CBPY(ISCAN1) + CSOLBY(ISCAN1)
      CBPZ1(ISCAN1) = CBPZ(ISCAN1) + CSOLBZ(ISCAN1)
        
      endif
     
     
     
      !* End loop over NF-positions
      ENDDO

!$OMP END DO      
!$OMP END PARALLEL 

      END SUBROUTINE NEARFIELD






    
    
    
    
    
    
    
    
    
    
!**********************************************************************
!*      Calculate Far-field radiation from dipoles above substrate
!**********************************************************************

!**************************************************************
!   SUBROUTINE DIPOLE RADIATION FAR-FIELD
!         C. GIRARD, A. ARBOUET - CEMES - 2013
!         originally from: G. Colas des Francs, C. Girard
!   UNITS = nanometers
!
!   - adapted for f2py as python module 2017 by P. Wiecha
!   - asymptotic propagator below surface 2019 by C. Majorel
!
!**************************************************************
!
!**************** Implemented following **********************
! Francs, G. C. des, Girard, C. & Dereux, A.
! Theory of near-field optical imaging with a single molecule 
! as light source. 
! The Journal of Chemical Physics 117, 4659–4666 (2002).
!**************************************************************  
!**************************************************************

subroutine DIPOLEFARFIELD(r,teta,phi, &
                                & xd,yd,zd, &
                                & cpx, cpy, cpz,&
                                & eps0,eps1,alambda, &
                                & cex, cey, cez)
      
      
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
      real(dp), parameter    :: Pi=3.141592654_dp

      real(dp), intent(in)  :: r,teta,phi           ! Position at which to compute E-field (spherical coordinates)
      real(dp), intent(in)  :: xd,yd,zd            ! Position of radiating dipole
      complex(dp), intent(in)  :: cpx, cpy, cpz     ! complex dipole moment components
      complex(dp), intent(in)  :: eps0, eps1        ! dielectric constant of substrate and environment
                                                    ! (eps0 respectively eps1)
      real(dp), intent(in)  :: alambda            ! radiation wavelength (nm)
      
      complex(dp), intent(out) :: cex,cey,cez   ! COMPUTED E-field at (X,Y,Z)
      
      complex(dp) :: SsurfXX,SsurfXY,SsurfXZ,SsurfYX,SsurfYY,SsurfYZ,SsurfZX,SsurfZY,SsurfZZ
      complex(dp) :: SvacXX,SvacXY,SvacXZ,SvacYX,SvacYY,SvacYZ,SvacZX,SvacZY,SvacZZ
      complex(dp) :: SXX,SXY,SXZ,SYX,SYY,SYZ,SZX,SZY,SZZ
      complex(dp) :: A, Asurf, Avac ! common terms of propagators
      complex(dp) :: rs,rp
      complex(dp) :: delta_s,tau_s, phi_s
      complex(dp) :: delta_p,tau_p, phi_p
      complex(dp) :: n0, n1
      complex(dp) :: ak_vac, ak0, ak1, eps_diff
      real(dp) :: tetatop
      


!**************************************************************
!***************** COMPUTATION PARAMETERS *********************
!**************************************************************
       n0 = sqrt(eps0) ! substrate index
       n1 = sqrt(eps1) ! env. index
       ak_vac = 2.*Pi/alambda              ! wavevector in the substrate
       ak0 = 2.*Pi*n0/alambda              ! wavevector in the substrate
       ak1 = 2.*Pi*n1/alambda              ! wavevector in particle environment
       eps_diff = (eps0 - eps1 + 1._dp)     ! relative permittivity
       
       
!!!!! ABOVE SUBSTRATE ( Z=r*cos(teta) )
if (cos(teta) > -0.0000001) then
!! treat case of homogeneous environment specifically here
            tetatop = teta
            if ((teta > 1.570796).and.(teta<4.71238)) then
              tetatop = 1.570796
            endif
!**************************************************************
!******************* Surface propagator ***********************
!**************************************************************
!           Asurf = -ak1**2*exp(cim*n1*ak1*r) / r*exp(-cim*n1*ak1*sin(tetatop)*(xd*cos(phi) &
!                     & +yd*sin(phi)))*exp(cim*n1*ak1*cos(tetatop)*zd)
!           
!           rp = (eps0*n1*cos(tetatop)-eps1*sqrt(eps0-eps1*sin(tetatop)**2)) / &
!                  & (eps0*n1*cos(tetatop)+eps1*sqrt(eps0-eps1*sin(tetatop)**2))
!      
!           rs = (n1*cos(tetatop)-sqrt(eps0-eps1*sin(tetatop)**2)) / &
!                  & (n1*cos(tetatop)+sqrt(eps0-eps1*sin(tetatop)**2))
!      
!           !! -- matrix elements
!           SsurfXX = rp*cos(tetatop)**2*cos(phi)**2-rs*sin(phi)**2
!           SsurfXY = (rp*cos(tetatop)**2+rs)*sin(phi)*cos(phi)
!           SsurfXZ = rp*cos(tetatop)*sin(tetatop)*cos(phi)
!           SsurfYX = SsurfXY
!           SsurfYY = rp*cos(tetatop)**2*sin(phi)**2-rs*cos(phi)**2
!           SsurfYZ = rp*cos(tetatop)*sin(tetatop)*sin(phi)
!           SsurfZX = -SsurfXZ
!           SsurfZY = -SsurfYZ
!           SsurfZZ = -rp*sin(tetatop)**2

!           rs = (cos(tetatop)-sqrt(eps_diff-(sin(tetatop))**2))/(cos(tetatop)+sqrt(eps_diff-(sin(tetatop))**2))
!           rp = (eps_diff*cos(tetatop)-sqrt(eps_diff-(sin(tetatop))**2))/(eps_diff*cos(tetatop)+sqrt(eps_diff-(sin(tetatop))**2))
          rp = ((eps0*n1*cos(tetatop) - eps1*sqrt(eps0 - eps1*sin(tetatop)**2)) / &
                 & (eps0*n1*cos(tetatop) + eps1*sqrt(eps0 - eps1*sin(tetatop)**2)))
        
          rs = ((n1*cos(tetatop) - sqrt(eps0 - eps1*sin(tetatop)**2)) / &
                & (n1*cos(tetatop) + sqrt(eps0 - eps1*sin(tetatop)**2)))

      
          Asurf = -ak_vac**2*exp(cim*ak1*r) / r * &
                       & exp(-cim*ak1*SIN(tetatop)*(COS(phi)*xd+SIN(phi)*yd)) * &
                       & exp(cim*ak1*COS(tetatop)*zd)
!           Asurf = -ak1**2*exp(cim*ak1*r) / r * &
!                        & exp(-cim*ak1*SIN(tetatop)*(COS(phi)*xd+SIN(phi)*yd)) * &
!                        & exp(cim*ak1*COS(tetatop)*zd)

          SsurfXX =  rp*(COS(tetatop))**2*(COS(phi))**2 - rs*(SIN(phi))**2 
          SsurfXY =  (rp*(COS(tetatop))**2+rs)*SIN(phi)*COS(phi)
          SsurfXZ =  rp*SIN(tetatop)*COS(tetatop)*COS(phi)
          SsurfYX =  SsurfXY
          SsurfYY =  rp*(COS(tetatop))**2*(SIN(phi))**2 - rs*(COS(phi))**2  ! modif !
          SsurfYZ =  rp*SIN(tetatop)*COS(tetatop)*SIN(phi)
          SsurfZX =  -rp*SIN(tetatop)*COS(tetatop)*COS(phi)  
          SsurfZY =  -rp*SIN(tetatop)*COS(tetatop)*SIN(phi)        
          SsurfZZ =  -rp*(SIN(tetatop))**2


          SsurfXX =  Asurf*SsurfXX
          SsurfXY =  Asurf*SsurfXY
          SsurfXZ =  Asurf*SsurfXZ
          SsurfYX =  Asurf*SsurfYX
          SsurfYY =  Asurf*SsurfYY
          SsurfYZ =  Asurf*SsurfYZ
          SsurfZX =  Asurf*SsurfZX
          SsurfZY =  Asurf*SsurfZY
          SsurfZZ =  Asurf*SsurfZZ

!**************************************************************
!******************* Vacuum propagator ************************
!**************************************************************

      Avac = ak_vac**2*exp(cim*ak1*r) / r * &
           & exp(-cim*ak1*SIN(tetatop)*(COS(phi)*xd+SIN(phi)*yd)) * &
           & exp(-cim*ak1*COS(tetatop)*zd)

          SvacXX =  1._dp-(SIN(tetatop))**2*(COS(phi))**2
          SvacXY =  -(SIN(tetatop))**2*COS(phi)*SIN(phi)
          SvacXZ =  -SIN(tetatop)*COS(tetatop)*COS(phi)
          SvacYX =  -(SIN(tetatop))**2*COS(phi)*SIN(phi)
          SvacYY =  1._dp-(SIN(tetatop))**2*(SIN(phi))**2
          SvacYZ =  -SIN(tetatop)*COS(tetatop)*SIN(phi)
          SvacZX =  -SIN(tetatop)*COS(tetatop)*COS(phi)
          SvacZY =  -SIN(tetatop)*COS(tetatop)*SIN(phi)
          SvacZZ =  (SIN(tetatop))**2
      
          SvacXX =  Avac*SvacXX
          SvacXY =  Avac*SvacXY
          SvacXZ =  Avac*SvacXZ
          SvacYX =  Avac*SvacYX
          SvacYY =  Avac*SvacYY
          SvacYZ =  Avac*SvacYZ
          SvacZX =  Avac*SvacZX
          SvacZY =  Avac*SvacZY
          SvacZZ =  Avac*SvacZZ 

!**************************************************************
!******************* Total propagator *************************
!**************************************************************
          if (eps1==eps0) then
          ! vacuum contribution only
            SXX =  SvacXX
            SXY =  SvacXY
            SXZ =  SvacXZ
            SYX =  SvacYX
            SYY =  SvacYY
            SYZ =  SvacYZ
            SZX =  SvacZX
            SZY =  SvacZY
            SZZ =  SvacZZ
          else
          ! if eps1!=eps0, add surface term
            SXX =  SvacXX + SsurfXX
            SXY =  SvacXY + SsurfXY
            SXZ =  SvacXZ + SsurfXZ
            SYX =  SvacYX + SsurfYX
            SYY =  SvacYY + SsurfYY
            SYZ =  SvacYZ + SsurfYZ
            SZX =  SvacZX + SsurfZX
            SZY =  SvacZY + SsurfZY
            SZZ =  SvacZZ + SsurfZZ  
          endif

!!!!! BELOW SUBSTRATE ( Z=r*cos(teta) )
elseif (cos(teta) <= 0.0000001) then
!**************************************************************
!******* Asymptot. surface propagator below *****************
!**************************************************************                      
          A = sqrt(eps1 - eps0 * sin(teta)**2)
          
          Asurf = (ak_vac**2)*exp(cim*ak0*r)/r*exp(-cim*ak0*sin(teta)* &
                   & (xd*cos(phi)+yd*sin(phi)))*exp(cim*ak_vac*A*zd)
!           Asurf = (ak1**2)*exp(cim*ak0*r)/r*exp(-cim*ak0*sin(teta)* &
!                    & (xd*cos(phi)+yd*sin(phi)))*exp(cim*ak1*A*zd)

          
          delta_s = (-n0*cos(teta)-A) / (-n0*cos(teta)+A)
          tau_s = 1. - delta_s
          phi_s = tau_s*n0/A 
      
          delta_p = (-eps1*n0*cos(teta)-eps0*A) / (-eps1*n0*cos(teta)+eps0*A)
          tau_p = delta_p + 1.
          phi_p = n0*tau_p*A
          
          !! -- asymptotic surface propagator (inside surface)
          SsurfXX = (phi_p/eps1*cos(phi)**2+phi_s*sin(phi)**2)*cos(teta)
          SsurfXY = (phi_p/eps1-phi_s)*cos(teta)*sin(phi)*cos(phi)
          SsurfXZ = tau_p*eps0/eps1*cos(phi)*cos(teta)*sin(teta)
          SsurfYX = (phi_p/eps1-phi_s)*cos(teta)*sin(phi)*cos(phi)
          SsurfYY = (phi_p/eps1*sin(phi)**2+phi_s*cos(phi)**2)*cos(teta)
          SsurfYZ = tau_p*eps0/eps1*sin(phi)*cos(teta)*sin(teta)
          SsurfZX = -phi_p/eps1*sin(teta)*cos(phi)
          SsurfZY = -phi_p/eps1*sin(teta)*sin(phi)
          SsurfZZ = -tau_p*eps0/eps1*sin(teta)**2
      
      
      
      
          SXX =  Asurf*SsurfXX
          SXY =  Asurf*SsurfXY
          SXZ =  Asurf*SsurfXZ
          SYX =  Asurf*SsurfYX
          SYY =  Asurf*SsurfYY
          SYZ =  Asurf*SsurfYZ
          SZX =  Asurf*SsurfZX
          SZY =  Asurf*SsurfZY
          SZZ =  Asurf*SsurfZZ 

endif        
!**************************************************************
!******************* COMPUTING E-FIELD ************************
!**************************************************************
          
          cex = SXX*cpx + SXY*cpy + SXZ*cpz
          cey = SYX*cpx + SYY*cpy + SYZ*cpz
          cez = SZX*cpx + SZY*cpy + SZZ*cpz
          
          end subroutine DIPOLEFARFIELD

          

    
    

!******************************************************************
! far-field polarization from NPOL dipoles 
! in environment "eps1" above surface "eps0"
!******************************************************************

!**************************************************************
!   SUBROUTINE MULTI DIPOLE RADIATION TO FAR-FIELD
!               polarization filtered in image-plane
!
!         P. WIECHA, A. ARBOUET - CEMES - 2014
!
!   Adapted for f2py python module 2017 by P. Wiecha
!
!**************************************************************

      subroutine MULTIDIPOLEFARFIELD(ALAMBDA, Ntetasca, Nphi, &
                     & tetamin, tetamax, &
                     & r, eps0, eps1, polarizerangle, &
                     & XDP,YDP,ZDP, &
                     & CPPX,CPPY,CPPZ, &
                     & NDP, &
                     & tetalist, philist, &
                     & IntensInt, IntensIntPol, IntensPol, Intens, &
                     & cexSC, ceySC, cezSC, ceSCpol)
!                      NTHREADS, &
      
!                      & CEX0,CEY0,CEZ0, &
      
      !f2py threadsafe
      !$ use OMP_LIB
!       use OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      !! Constants
      complex(dp), parameter :: c0=(0._dp,0._dp)
      complex(dp), parameter :: cun=(1._dp,0._dp)
      complex(dp), parameter :: cim=(0._dp,1._dp)
      real(dp), parameter :: Pi=3.141592654_dp
      
      
      !! Input
      integer, intent(in)           :: NDP
      integer, intent(in)           :: Ntetasca,Nphi
      real(dp), intent(in)  :: tetamin, tetamax
      real(dp), intent(in)  :: polarizerangle
      real(dp), intent(in)  :: r, ALAMBDA
      complex(dp), intent(in)    :: eps0, eps1
      real(dp), DIMENSION(NDP), intent(in) :: XDP,YDP,ZDP                ! dipoles positions
      complex(dp), DIMENSION(NDP), intent(in) :: CPPX,CPPY,CPPZ    ! electric polarization of structure dipoles
!       integer, intent(in) :: NTHREADS
!       complex(dp), DIMENSION(Ntetasca, Nphi), intent(in) :: CEX0,CEY0,CEZ0    ! precalculated fundamental field at sphere
      
      
      !! Output
      real(dp), intent(out)         :: IntensInt, IntensIntPol
      real(dp), DIMENSION(Ntetasca, Nphi), intent(out) :: tetalist, philist
      complex(dp), DIMENSION(Ntetasca, Nphi), intent(out) :: cexSC, ceySC, cezSC, ceSCpol
      real(dp), DIMENSION(Ntetasca, Nphi), intent(out)       :: Intens
      real(dp), DIMENSION(Ntetasca, Nphi), intent(out) :: IntensPol
      
      
      !! Internally used
      real(dp) :: dteta, dphi, dSurf, tetasca, phi
      integer          :: Itetasca, Iphi, IS

      complex(dp) :: CEX, CEY, CEZ
      complex(dp) :: cexSCtmp, ceySCtmp, cezSCtmp
      complex(dp)   :: CEPPAR, CEPPERP, CEPPOL
      
!       integer :: NTHREADSUSE
      
      
      !! OpenMP Parallel
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)
      
      
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!         Calculate Farfield and extract polarization
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      dteta = (tetamax-tetamin)/(Ntetasca-1._dp)  ! teta: tetamin --> tetamax, including 'tetamax'
      dphi = 2._dp*Pi/(Nphi)                     ! phi: 0 - 360deg --> excluding 360deg

!$OMP PARALLEL DO DEFAULT(SHARED) &
!$OMP& FIRSTPRIVATE(r,tetasca,phi, dphi,dteta, &
!$OMP&              eps0,eps1,ALAMBDA, cexSCtmp,ceySCtmp,cezSCtmp, &
!$OMP&              CEX, CEY, CEZ, polarizerangle, CEPPAR,CEPPERP,CEPPOL)
      ! Numerical Integration
       DO Itetasca=1,Ntetasca
         DO Iphi=1,Nphi
           
           tetasca = tetamin + (Itetasca-1._dp)*dteta
           phi = (Iphi-1._dp)*dphi
           
           tetalist(Itetasca,Iphi) = tetasca
           philist(Itetasca,Iphi) = phi
           
           cexSCtmp = C0
           ceySCtmp = C0
           cezSCtmp = C0
            
           DO IS=1,NDP
!**************************************************************
!            COMPUTING E-FIELD intensity in far-field
!**************************************************************
             call DIPOLEFARFIELD(r,tetasca,phi, &
                        & XDP(IS), YDP(IS), ZDP(IS), &
                        & CPPX(IS), CPPY(IS), CPPZ(IS), &
                        & eps0, eps1, ALAMBDA, &
                        & CEX, CEY, CEZ)
                   
             cexSCtmp = cexSCtmp + CEX
             ceySCtmp = ceySCtmp + CEY
             cezSCtmp = cezSCtmp + CEZ
           ENDDO ! end of Do loop on dipoles
      
           cexSC(Itetasca,Iphi) = cexSCtmp
           ceySC(Itetasca,Iphi) = ceySCtmp
           cezSC(Itetasca,Iphi) = cezSCtmp
            
!**************************************************************
!            EXTRACT INTENSITY ALONG POLARIZATIONS
!**************************************************************
           ! Components parallel/perp. to polarizer
             CEPPAR = cexSCtmp*COS(phi)*COS(tetasca) + &
                          & ceySCtmp*SIN(phi)*COS(tetasca) - &
                          & cezSCtmp*SIN(tetasca)                  ! Scattered E-field parallel to scattering plane
             CEPPERP = cexSCtmp*SIN(phi) - &
                            & ceySCtmp*COS(phi)                      ! Scattered E-field perpendicular to scattering plane
             CEPPOL = CEPPAR*COS(polarizerangle-phi) - &
                          & CEPPERP*SIN(polarizerangle-phi)   ! Scattered E-field parallel to polarizer
             ceSCpol(Itetasca,Iphi) = CEPPOL
            
             ! total and polarization-filtered intensities at teta/phi-position
             Intens(Itetasca,Iphi) = (abs(cexSCtmp)**2 + abs(ceySCtmp)**2 + abs(cezSCtmp)**2)
             IntensPol(Itetasca,Iphi) = ABS(CEPPOL)**2
           
         ENDDO ! end of Do loop on phi
       ENDDO ! end of Do loop on tetasca
!$OMP END PARALLEL DO
      

! integrate intensities in non-parallel loop
       IntensInt = 0._dp
       IntensIntPol = 0._dp
       DO Itetasca=1,Ntetasca
       tetasca =  tetamin + (Itetasca-1._dp)*dteta
       dSurf = r**2*SIN(tetasca)*dteta*dphi  ! <-- solid-angle surface element
       
         DO Iphi=1,Nphi
            IntensInt      = IntensInt + Intens(Itetasca,Iphi) * dSurf 
            IntensIntPol = IntensIntPol + IntensPol(Itetasca,Iphi) * dSurf 
         ENDDO ! end of Do loop on phi
       ENDDO ! end of Do loop on tetasca


      END SUBROUTINE MULTIDIPOLEFARFIELD
      
      
      

!
!    Copyright (C) 2017, P. R. Wiecha, A. Arbouet, C. Girard
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!    
!!*********************************************************************
! Author: Christian Girard 
! CEMES/CNRS 
!
! Date: January 1997
!
! ***********
! Modified 2016 by P.R. Wiecha
! CEMES/CNRS
!   - variable precision
!
!*********************************************************************


!C*****Christian GIRARD, 24 Janvier 1997***************************
      SUBROUTINE ELECMAG0(AK0,XC,YC,ZC,EBXY1,EBXZ1,EBYZ1, &
                                               & EBXY2,EBXZ2,EBYZ2)
     
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      complex(dp), parameter :: c0=(0._dp,0._dp)
      complex(dp), parameter :: cun=(1._dp,0._dp)
      complex(dp), parameter :: cim=(0._dp,1._dp)
      real(dp), parameter :: Pi=3.141592654_dp
      
      
      real(dp) :: AK0,AK02
      real(dp) :: XC,YC,ZC
      real(dp) :: EBXY1,EBXZ1,EBYZ1
      real(dp) :: EBXY2,EBXZ2,EBYZ2
      complex(dp) :: CK0
      real(dp) :: T2XY,T2YZ,T2XZ
      real(dp) :: T3XY,T3YZ,T3XZ
      real(dp) :: RMO
      complex(dp) :: CFEXP
      complex(dp) :: CTXY,CTYZ,CTXZ
      
      
      AK02=AK0**2
      CK0=CIM*AK0
!C*****************************************************************
!C******CONSTRUCTION DES PROPAGATEURS RETARDES  *******************
!C*****************************************************************
      RMO=(XC*XC+YC*YC+ZC*ZC)
!C-----------------------------------------------------------------
      T2XY=-ZC/RMO
      T3XY=-ZC/RMO**1.5
!C-----------------------------------------------------------------
      T2XZ=YC/RMO
      T3XZ=YC/RMO**1.5
!C-----------------------------------------------------------------
      T2YZ=-XC/RMO
      T3YZ=-XC/RMO**1.5
!C-----------------------------------------------------------------
      CFEXP=EXP(CIM*AK0*SQRT(RMO))
      
      CTXY=CFEXP*(CK0*T3XY + AK02*T2XY)
      CTXZ=CFEXP*(CK0*T3XZ + AK02*T2XZ)
      CTYZ=CFEXP*(CK0*T3YZ + AK02*T2YZ)
      
      EBXY1=REAL(CTXY)
      EBXZ1=REAL(CTXZ)
      EBYZ1=REAL(CTYZ)
      EBXY2=AIMAG(CTXY)
      EBXZ2=AIMAG(CTXZ)
      EBYZ2=AIMAG(CTYZ)
      END





!! --- helper-routine to get full S^EB tensor (complex)
!! --- input parameters follow the convention: S^EB (R_OBS, R_C)
SUBROUTINE ELECMAG0_FULL(AK0,XC,YC,ZC, XOBS,YOBS,ZOBS, &
              & CEBXX, CEBXY, CEBXZ, &
              & CEBYX, CEBYY, CEBYZ, &
              & CEBZX, CEBZY, CEBZZ, &
              & cn1,cn2,cn3)
     
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      complex(dp), parameter :: c0=(0._dp,0._dp)
      complex(dp), parameter :: cun=(1._dp,0._dp)
      complex(dp), parameter :: cim=(0._dp,1._dp)
      real(dp), parameter :: Pi=3.141592654_dp
      
      
      real(dp), intent(in) :: AK0
      real(dp), intent(in) :: XC,YC,ZC
      real(dp), intent(in) :: XOBS,YOBS,ZOBS
      real(dp) :: XDDD,YDDD,ZDDD
      
      real(dp) :: EBXY1,EBXZ1,EBYZ1
      real(dp) :: EBXY2,EBXZ2,EBYZ2
!       real(dp) :: EBXX1,EBXY1,EBXZ1
!       real(dp) :: EBYX1,EBYY1,EBYZ1
!       real(dp) :: EBZX1,EBZY1,EBZZ1
!       real(dp) :: EBXX2,EBXY2,EBXZ2
!       real(dp) :: EBYX2,EBYY2,EBYZ2
!       real(dp) :: EBZX2,EBZY2,EBZZ2
      
      complex(dp), intent(in) :: cn1,cn2,cn3
      
!       complex(dp) :: CTXY,CTYZ,CTXZ
      
      complex(dp), intent(out) :: CEBXX, CEBYY, CEBZZ
      complex(dp), intent(out) :: CEBXY, CEBYX, CEBXZ
      complex(dp), intent(out) :: CEBZX, CEBYZ, CEBZY
      
!       if ( (cn1.ne.cn2).or.(cn1.ne.cn3) ) then
!        write (*,*) "Error. Only defined for homogeneous media! please use according refractive-indices."
!       end if
      
      XDDD = XOBS - XC
      YDDD = YOBS - YC
      ZDDD = ZOBS - ZC
      
        CALL ELECMAG0(AK0,XDDD,YDDD,ZDDD,&
            & EBXY1,EBXZ1,EBYZ1,&
            & EBXY2,EBXZ2,EBYZ2)
        CEBXX=C0
        CEBYY=C0
        CEBZZ=C0
        CEBXY=EBXY1*CUN+EBXY2*CIM
        CEBYX=-CEBXY
        CEBXZ=EBXZ1*CUN+EBXZ2*CIM
        CEBZX=-CEBXZ
        CEBYZ=EBYZ1*CUN+EBYZ2*CIM
        CEBZY=-CEBYZ
      END 
        
        
        

!! --- helper-routine to get full S^EB tensor (complex)
!! --- input parameters follow the convention: S^BB (R_OBS, R_C)
SUBROUTINE MAGMAG0_FULL(AK0, XOBS,YOBS,ZOBS, XC,YC,ZC, &
              & CBBXX, CBBXY, CBBXZ, &
              & CBBYX, CBBYY, CBBYZ, &
              & CBBZX, CBBZY, CBBZZ, &
              & cn1,cn2,cn3)
     
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      complex(dp), parameter :: c0=(0._dp,0._dp)
      complex(dp), parameter :: cun=(1._dp,0._dp)
      complex(dp), parameter :: cim=(0._dp,1._dp)
      real(dp), parameter :: Pi=3.141592654_dp
      
      real(dp), intent(in) :: AK0
      real(dp), intent(in) :: XC,YC,ZC
       real(dp), intent(in) :: XOBS,YOBS,ZOBS
      real(dp) :: ALAMBDA, SPACING
      
      complex(dp), intent(in) :: cn1,cn2,cn3
      
      complex(dp), intent(out) :: CBBXX, CBBYY, CBBZZ
      complex(dp), intent(out) :: CBBXY, CBBYX, CBBXZ
      complex(dp), intent(out) :: CBBZX, CBBYZ, CBBZY
      
      ALAMBDA = 2._dp*Pi/AK0
      SPACING = 5000
      
        CALL PROPAGATOR123(ALAMBDA,&
                & XOBS,YOBS,ZOBS,XC,YC,ZC, SPACING,&
                & CBBXX,CBBXY,CBBXZ,CBBYX,CBBYY,CBBYZ,CBBZX,CBBZY,CBBZZ, &
                & cn1,cn2,cn3)
        
      END 
!!    -----------------------------------------------------------------------

!
!    Copyright (C) 2017, P. R. Wiecha, A. Arbouet, C. Girard
!
!    This program is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with this program.  If not, see <http://www.gnu.org/licenses/>.
!    
!
!*********************************************************************
! Original Author: Christian Girard 
! CEMES/CNRS 
!
! Date: 24 January 1996 
! Modified: April 1997 
! Including the renormalisation terms
!
! ***********
! Modified 2010-2012 by A. Arbouet, R. Marty
! CEMES/CNRS
!   - openMP parallelization of matrix setup, Dyson sequence
!
! ***********
! Modified 2014-2016 by P.R. Wiecha
! CEMES/CNRS
!   - separated matrix setup / Dyson sequence
!
!*********************************************************************




!*********************************************************************
!--------------------------------------------------------------------*
!         Implements the the side-by-side matrix "S" containing      *
!         the coupled free-space and surface propagators             *
!         for the system (XM,YM,ZM).                                 *
!         The inverse of this matrix is the generalized propagator K *
!         with the property: K*E0 = E                                *
!--------------------------------------------------------------------*
!*********************************************************************
      SUBROUTINE SETUPMATRIX(ALAMBDA,SPACE, &
	          & XM,YM,ZM,  &
	          & CAP, &
	          & cn1,cn2,cn3, &
	          & CNORM, TIMESALPHA, PROPAGATOR, &
	          & NMAX, &
	          & CAM0)
! 	          NTHREADS, &
      
      !f2py threadsafe
      !$ use OMP_LIB
      USE OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none
      
      
!**********************************************************************
!*      CONFIGURATION
!**********************************************************************
      ! Fixed allocations
      real(dp), parameter :: Pi=3.141592654_dp
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
     
     
      integer :: I,J,II,JJ
      integer, intent(in) :: NMAX 
      integer, intent(in) :: TIMESALPHA
!       integer, intent(in) :: NTHREADS
      complex(dp),   intent(in) :: cn1,cn2,cn3
      real(dp), intent(in) :: ALAMBDA
      real(dp), intent(in) :: SPACE
      real(dp), intent(in) :: XM(NMAX),YM(NMAX),ZM(NMAX)
      complex(dp), intent(in) :: CAP(NMAX)  ! complex polarizabilities of each meshpoint
      complex(dp), intent(in) :: CNORM  ! mesh-type dependent normalization factor
      
      !*** --- PROPAGATOR TO USE: --- ***
      !         - 1: 'simple 123'
      !         - 2: 'full 123'
      integer, intent(in) :: PROPAGATOR
      !**********************************
      
      complex(dp), intent(out) :: CAM0(3*NMAX,3*NMAX)
     
     
     
!**********************************************************************
!*      DECLARATION
!**********************************************************************
!       integer :: NTHREADSUSE
      real(dp) :: AK00
      real(dp) :: XI,YI,ZI,XJ,YJ,ZJ,ZS,XD,YD,ZD
      complex(dp) :: CHXX,CHXY,CHXZ,CHYX,CHYY,CHYZ,CHZX,CHZY,CHZZ
      complex(dp) :: SXX,SXY,SXZ,SYY,SYZ,SZZ
      complex(dp) :: CTXX,CTXY,CTXZ,CTYY,CTYZ,CTZZ
      complex(dp) :: CSXX,CSXY,CSXZ,CSYY,CSYZ,CSZZ!,CSYX,CSZX,CSZY
      real(dp) :: TXX,TXY,TXZ,TYY,TYZ,TZZ
      real(dp) :: TXX2,TXY2,TXZ2,TYY2,TYZ2,TZZ2
      
      complex(dp) :: CAXX(NMAX), CAYY(NMAX), CAZY(NMAX)
      complex(dp) :: CAZZ(NMAX), CAXY(NMAX), CAXZ(NMAX)
      complex(dp) :: CAYX(NMAX), CAYZ(NMAX), CAZX(NMAX)
     
      
      
      
      
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)
 
!*********************************************************************
!*          INITIALIZATION
!*********************************************************************
      AK00=2._dp*Pi/ALAMBDA
     
      if (TIMESALPHA==1) then
!-----(1) Definition of the anisotropic polarizability of each -------
!---------------------discretized  cell ------------------------------
        DO J=1,NMAX
            CAXX(J)=CAP(J)
            CAYY(J)=CAP(J)
            CAZZ(J)=CAP(J)
            CAXY(J)=C0
            CAYX(J)=C0
            CAXZ(J)=C0
            CAZX(J)=C0
            CAZY(J)=C0
            CAYZ(J)=C0
        ENDDO
     else
     !! if demanded, don't multiply by polarizability (for python-treated inversion)
     !! --> use unitary tensor for polarizability
        DO J=1,NMAX
            CAXX(J)=CUN
            CAYY(J)=CUN
            CAZZ(J)=CUN
            CAXY(J)=C0
            CAYX(J)=C0
            CAXZ(J)=C0
            CAZX(J)=C0
            CAZY(J)=C0
            CAYZ(J)=C0
        ENDDO
     endif


!---------Initialization of the matrix composed with ----------------
!-------------------site-to-site propagators-------------------------
!--------------------------AM0(I,J)----------------------------------
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP& FIRSTPRIVATE(XJ,YJ,ZJ,JJ, XI,YI,ZI,II, XD,YD,ZD,ZS, &
!$OMP&              SXX,SYY,SZZ,SXY,SXZ,SYZ,  &
!$OMP&              CHXX,CHYY,CHZZ,CHXY,CHYX,CHYZ,CHZY,CHXZ,CHZX, &
!$OMP&              TXX,TYY,TZZ,TXY,TXZ,TYZ,TXX2,TYY2,TZZ2,TXY2,TXZ2,TYZ2, &
!$OMP&              CTXX,CTYY,CTZZ,CTXY,CTXZ,CTYZ, &
!$OMP&              CSXX,CSYY,CSZZ,CSXY,CSXZ,CSYZ &
!$OMP&              )

!$OMP DO
      DO J=1,NMAX
        
        XJ=XM(J)
        YJ=YM(J)
        ZJ=ZM(J)
        JJ=3*(J-1)

        DO I=1,NMAX
            XI=XM(I)
            YI=YM(I)
            ZI=ZM(I)
            II=3*(I-1)

!C*************************************************************************
!C****** simple model: vacuum propagator + 1/2/3-surface, material in center medium
!C*************************************************************************
            if (PROPAGATOR==1) then
            ! --- "self"-term
            IF(I.EQ.J)THEN
                XD=0._dp
                YD=0._dp
                ZS=ZI+ZJ
                
                !! --- Surface propagator
                CALL PROPAS(XD,YD,ZS,SXX,SYY,SZZ,SXY,SXZ,SYZ,SPACE, &
                          & cn1,cn2,cn3) 
                
                !! Setup matrix G. Final matrix to inverse will be: (1 - G.alpha)
                CHXX = (SXX+CNORM)
                CHYY = (SYY+CNORM)
                CHZZ = (SZZ+CNORM)
                     
                CHXY =   SXY*CUN
                CHYX =   SXY*CUN
                CHYZ =   SYZ*CUN
                CHZY = (-1._dp*SYZ*CUN)
                CHXZ =   SXZ*CUN
                CHZX = (-1._dp*SXZ*CUN)
                
            ! --- Couple 2 different dipoles
            ELSE
                    XD=XI-XJ
                    YD=YI-YJ
                    ZD=ZI-ZJ
                    ZS=ZI+ZJ
                
!                     write (*,*) "prop1"
                    !! --- Vacuum propagator
                    CALL PROPA0(AK00,XD,YD,ZD,TXX,TYY,TZZ,&
                            & TXY,TXZ,TYZ,TXX2,TYY2,TZZ2,TXY2,TXZ2,TYZ2,&
                            & cn2)
                    
                    CTXX=TXX*CUN+TXX2*CIM
                    CTYY=TYY*CUN+TYY2*CIM
                    CTZZ=TZZ*CUN+TZZ2*CIM
                    CTXY=TXY*CUN+TXY2*CIM
                    CTXZ=TXZ*CUN+TXZ2*CIM
                    CTYZ=TYZ*CUN+TYZ2*CIM
                    
                    !! --- Surface propagator
                    CALL PROPAS(XD,YD,ZS,SXX,SYY,SZZ,SXY,SXZ,SYZ,SPACE,&
                            & cn1,cn2,cn3)
                    
                    CSXX=SXX*CUN
                    CSYY=SYY*CUN
                    CSZZ=SZZ*CUN
                    CSXY=SXY*CUN
                    CSXZ=SXZ*CUN
                    CSYZ=SYZ*CUN
                !------------------------------------------------------------------
                    CHXX = (CTXX+CSXX)
                    CHYY = (CTYY+CSYY)
                    CHZZ = (CTZZ+CSZZ)
                    CHXY = (CTXY+CSXY)
                    CHXZ = (CTXZ+CSXZ)
                    CHYZ = (CTYZ+CSYZ)
                    CHYX = (CTXY+CSXY)
                    CHZY = (CTYZ-CSYZ)
                    CHZX = (CTXZ-CSXZ)
                endif
                
! !C*************************************************************************
! !C****** magnetic propagator (in vacuum)
! !C*************************************************************************
                elseif (PROPAGATOR==2) then
                ! --- self-term
                IF(I.EQ.J)THEN
                ! --- "self"-term
                CHXX = CNORM
                CHYY = CNORM
                CHZZ = CNORM
                     
                CHXY = C0
                CHYX = C0
                CHYZ = C0
                CHZY = C0
                CHXZ = C0
                CHZX = C0
                
                ELSE
                ! --- Couple 2 different dipoles
!                   write (*,*) "prop2"
                    CALL ELECMAG0_FULL(AK00, &
                                        & XJ,YJ,ZJ, XI,YI,ZI, &
                                        & CHXX, CHXY, CHXZ, &
                                        & CHYX, CHYY, CHYZ, &
                                        & CHZX, CHZY, CHZZ, &
                                        & cn1,cn2,cn3)
                endif
            ENDIF
            
            
            ! multiply by anisotropic polarizability tensor
            ! "-" for  (1 - G*alpha); below treat only diagonal elements
            CAM0(II+1,JJ+1) = (CHXX*CAXX(J) + CHXY*CAYX(J) + CHXZ*CAZX(J))
            CAM0(II+2,JJ+1) = - (CHYX*CAXX(J) + CHYY*CAYX(J) + CHYZ*CAZX(J))
            CAM0(II+3,JJ+1) = - (CHZX*CAXX(J) + CHZY*CAYX(J) + CHZZ*CAZX(J))
            
            CAM0(II+1,JJ+2) = - (CHXX*CAXY(J) + CHXY*CAYY(J) + CHXZ*CAZY(J))
            CAM0(II+2,JJ+2) = (CHYX*CAXY(J) + CHYY*CAYY(J) + CHYZ*CAZY(J))
            CAM0(II+3,JJ+2) = - (CHZX*CAXY(J) + CHZY*CAYY(J) + CHZZ*CAZY(J))
            
            CAM0(II+1,JJ+3) = - (CHXX*CAXZ(J) + CHXY*CAYZ(J) + CHXZ*CAZZ(J))
            CAM0(II+2,JJ+3) = - (CHYX*CAXZ(J) + CHYY*CAYZ(J) + CHYZ*CAZZ(J))
            CAM0(II+3,JJ+3) = (CHZX*CAXZ(J) + CHZY*CAYZ(J) + CHZZ*CAZZ(J))
            
            
            ! Matrix to inverse: CAM0 = (1-G.alpha) 
            ! -->Substract from unitary tensor
            IF(I.EQ.J)THEN
                CAM0(II+1,JJ+1) = 1_dp - CAM0(II+1,JJ+1)
                CAM0(II+2,JJ+2) = 1_dp - CAM0(II+2,JJ+2)
                CAM0(II+3,JJ+3) = 1_dp - CAM0(II+3,JJ+3)
            ELSE
                CAM0(II+1,JJ+1) = - CAM0(II+1,JJ+1)
                CAM0(II+2,JJ+2) = - CAM0(II+2,JJ+2)
                CAM0(II+3,JJ+3) = - CAM0(II+3,JJ+3)
            ENDIF
            
            
! ------------ sub-tensor components in CAM0: ------------
!             CAM0(II+1,JJ+1) --> XX
!             CAM0(II+2,JJ+1) --> YX
!             CAM0(II+3,JJ+1) --> ZX
!             CAM0(II+1,JJ+2) --> XY
!             CAM0(II+2,JJ+2) --> YY
!             CAM0(II+3,JJ+2) --> ZY
!             CAM0(II+1,JJ+3) --> XZ
!             CAM0(II+2,JJ+3) --> YZ
!             CAM0(II+3,JJ+3) --> ZZ
        
        ENDDO   ! inner loop on dipoles
      ENDDO   ! outer loop on dipoles
!$OMP ENDDO

!$OMP END PARALLEL

      END SUBROUTINE SETUPMATRIX


      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      

!********************************************************************
!--------------------------------------------------------------------*
!      Iversion of the matrix using a sequence of dyson equations    *
!                Returns the generalized Propagator K                *
!--------------------------------------------------------------------*
!*********************************************************************
      SUBROUTINE DYSONSEQ(ALAMBDA,SPACE, &
	          & XM,YM,ZM,  &
	          & CAP, &
	          & cn1,cn2,cn3, &
	          & CNORM, &
	          & NMAX, RETURNSUSC, &
	          & CAM0)
! 	          & NTHREADS, &
       
      !f2py threadsafe
      !$ use OMP_LIB
!       USE OMP_LIB
      USE PYGDMPRECISION, ONLY : dp
      implicit none

      
!**********************************************************************
!*      CONFIGURATION
!**********************************************************************
      ! Fixed allocations
      real(dp), parameter :: Pi=3.141592654_dp
      complex(dp), parameter :: C0=(0._dp,0._dp)
      complex(dp), parameter :: CUN=(1._dp,0._dp)
      complex(dp), parameter :: CIM=(0._dp,1._dp)
     
      ! parameters
      integer, intent(in) :: NMAX 
      integer, intent(in) :: RETURNSUSC
!       integer, intent(in) :: NTHREADS
      complex(dp),   intent(in) :: cn1,cn2,cn3
      real(dp), intent(in) :: ALAMBDA
      real(dp), intent(in) :: SPACE
      real(dp), intent(in) :: XM(NMAX),YM(NMAX),ZM(NMAX)
      complex(dp), intent(in) :: CAP(NMAX)  ! complex polarizabilities of each meshpoint
      complex(dp), intent(in) :: CNORM  ! mesh-type dependent normalization factor
      
      complex(dp), intent(out) :: CAM0(3*NMAX,3*NMAX)
     
      
      
!**********************************************************************
!*      DECLARATION
!**********************************************************************
!       integer :: NTHREADSUSE
      integer :: I,J,K,L,I1,J1,II,KK,JJ,LL,II1,JJ1
      real(dp) :: AK00
      
      real(dp) :: XI,YI,ZI,XJ,YJ,ZJ,ZS,XD,YD,ZD
      complex(dp) :: CHXX,CHXY,CHXZ,CHYX,CHYY,CHYZ,CHZX,CHZY,CHZZ
      complex(dp) :: SXX,SXY,SXZ,SYY,SYZ,SZZ
      complex(dp) :: CTXX,CTXY,CTXZ,CTYY,CTYZ,CTZZ
      complex(dp) :: CSXX,CSXY,CSXZ,CSYY,CSYZ,CSZZ
      real(dp) :: TXX,TXY,TXZ,TYY,TYZ,TZZ
      real(dp) :: TXX2,TXY2,TXZ2,TYY2,TYZ2,TZZ2
      
      complex(dp) :: CAXX(NMAX),CAYY(NMAX),CAZZ(NMAX),CAXY(NMAX)
      complex(dp) :: CAXZ(NMAX),CAYZ(NMAX),CAZX(NMAX),CAZY(NMAX),CAYX(NMAX)
      complex(dp) :: CVXX(NMAX),CVYY(NMAX),CVZZ(NMAX),CVXY(NMAX)
      complex(dp) :: CVXZ(NMAX),CVYX(NMAX),CVYZ(NMAX),CVZX(NMAX),CVZY(NMAX)
      complex(dp) :: CWWXX(NMAX),CWWYY(NMAX),CWWZZ(NMAX),CWWXY(NMAX)
      complex(dp) :: CWWXZ(NMAX),CWWYX(NMAX),CWWYZ(NMAX),CWWZX(NMAX),CWWZY(NMAX)
            
      complex(dp) :: CAAXX,CAAXY,CAAXZ,CAAYX,CAAYY,CAAYZ,CAAZX,CAAZY,CAAZZ
      complex(dp) :: CBXX,CBXY,CBXZ,CBYX,CBYY,CBYZ,CBZX,CBZY,CBZZ
      complex(dp) :: CXX,CXY,CXZ,CYX,CYY,CYZ,CZX,CZY,CZZ
      complex(dp) :: CDETERM,CDETER
      
     
     
      
      
      
!       IF (NTHREADS==-1) THEN
!         NTHREADSUSE = OMP_GET_MAX_THREADS()
!       ELSE
!         NTHREADSUSE = NTHREADS
!       ENDIF
!       CALL omp_set_num_threads(NTHREADSUSE)
 
 
!*********************************************************************
!*          INITIALIZATION
!*********************************************************************
 AK00=2._dp*Pi/ALAMBDA
     
  
!$OMP PARALLEL

!$OMP DO
!-----(1) Definition of the anisotropic polarizability of each -------
!---------------------discretized  cell ------------------------------
        DO J=1,NMAX
            CAXX(J)=CAP(J)
            CAYY(J)=CAP(J)
            CAZZ(J)=CAP(J)
            CAXY(J)=C0
            CAYX(J)=C0
            CAXZ(J)=C0
            CAZX(J)=C0
            CAZY(J)=C0
            CAYZ(J)=C0
        ENDDO
!$OMP ENDDO

!$OMP END PARALLEL


!---------Initialization of the matrix composed with ----------------
!-------------------site-to-site propagators-------------------------
!--------------------------AM0(I,J)----------------------------------
!$OMP PARALLEL DEFAULT(SHARED) &
!$OMP& FIRSTPRIVATE(XJ,YJ,ZJ,JJ, XI,YI,ZI,II, XD,YD,ZD,ZS, &
!$OMP&              SXX,SYY,SZZ,SXY,SXZ,SYZ,  &
!$OMP&              CHXX,CHYY,CHZZ,CHXY,CHYX,CHYZ,CHZY,CHXZ,CHZX, &
!$OMP&              TXX,TYY,TZZ,TXY,TXZ,TYZ,TXX2,TYY2,TZZ2,TXY2,TXZ2,TYZ2, &
!$OMP&              CTXX,CTYY,CTZZ,CTXY,CTXZ,CTYZ, &
!$OMP&              CSXX,CSYY,CSZZ,CSXY,CSXZ,CSYZ &
!$OMP&              )

!$OMP DO
      DO J=1,NMAX
        
        XJ=XM(J)
        YJ=YM(J)
        ZJ=ZM(J)
        JJ=3*(J-1)

        DO I=1,NMAX
            XI=XM(I)
            YI=YM(I)
            ZI=ZM(I)
            II=3*(I-1)

            IF(I.EQ.J)THEN
                ! --- "self"-term
                XD=0._dp
                YD=0._dp
                ZS=ZI+ZJ
                
                !! --- Surface propagator
                CALL PROPAS(XD,YD,ZS,SXX,SYY,SZZ,SXY,SXZ,SYZ,SPACE, &
                          & cn1,cn2,cn3) 
                
                !! Setup matrix G. Final matrix to inverse will be: (1 - G.alpha)
                CHXX = (SXX+CNORM)
                CHYY = (SYY+CNORM)
                CHZZ = (SZZ+CNORM)
                     
                CHXY =   SXY*CUN
                CHYX =   SXY*CUN
                CHYZ =   SYZ*CUN
                CHZY = (-1._dp*SYZ*CUN)
                CHXZ =   SXZ*CUN
                CHZX = (-1._dp*SXZ*CUN)
            ELSE
                ! --- Couple 2 different dipoles
                XD=XI-XJ
                YD=YI-YJ
                ZD=ZI-ZJ
                ZS=ZI+ZJ
                
                !! --- Vacuum propagator
                CALL PROPA0(AK00,XD,YD,ZD,TXX,TYY,TZZ,&
                          & TXY,TXZ,TYZ,TXX2,TYY2,TZZ2,TXY2,TXZ2,TYZ2,&
                          & cn2)
                
                CTXX=TXX*CUN+TXX2*CIM
                CTYY=TYY*CUN+TYY2*CIM
                CTZZ=TZZ*CUN+TZZ2*CIM
                CTXY=TXY*CUN+TXY2*CIM
                CTXZ=TXZ*CUN+TXZ2*CIM
                CTYZ=TYZ*CUN+TYZ2*CIM
                
                !! --- Surface propagator
                CALL PROPAS(XD,YD,ZS,SXX,SYY,SZZ,SXY,SXZ,SYZ,SPACE,&
                          & cn1,cn2,cn3)
                
                CSXX=SXX*CUN
                CSYY=SYY*CUN
                CSZZ=SZZ*CUN
                CSXY=SXY*CUN
                CSXZ=SXZ*CUN
                CSYZ=SYZ*CUN
            !------------------------------------------------------------------
                CHXX = (CTXX+CSXX)
                CHYY = (CTYY+CSYY)
                CHZZ = (CTZZ+CSZZ)
                CHXY = (CTXY+CSXY)
                CHXZ = (CTXZ+CSXZ)
                CHYZ = (CTYZ+CSYZ)
                CHYX = (CTXY+CSXY)
                CHZY = (CTYZ-CSYZ)
                CHZX = (CTXZ-CSXZ)
                
            ENDIF
            
            CAM0(II+1,JJ+1)=CHXX
            CAM0(II+2,JJ+1)=CHYX
            CAM0(II+3,JJ+1)=CHZX
            
            CAM0(II+1,JJ+2)=CHXY
            CAM0(II+2,JJ+2)=CHYY
            CAM0(II+3,JJ+2)=CHZY
            
            CAM0(II+1,JJ+3)=CHXZ
            CAM0(II+2,JJ+3)=CHYZ
            CAM0(II+3,JJ+3)=CHZZ
            
        ENDDO   ! inner loop on dipoles
      ENDDO   ! outer loop on dipoles
!$OMP ENDDO

!$OMP END PARALLEL












!$OMP PARALLEL

!-------------- Matrix inversion via Dyson-sequence------------------*
!      We use in this code the concept of generalized propagator:   *
!cf. O.J.F. Martin, Ch. Girard, A. Dereux, Phys. Rev. Let. 74(1995)526
!           combined with a 3D sequence of Dyson's equations        *
!cf. Ch. Girard, O.J.F. Martin, A. Dereux,Phys. Rev. Let. 75(1995)3098
!********************************************************************
!
!
!----------SEQUENCE OF DYSON EQUATION---------------------------------
!
!--------------(1) Summation on the atoms-----------------------------
      DO K=1,NMAX
        KK=3*(K-1)
    !--------- Filling the 3x3 matrix A(K) -------------------------------
        CAAXX=1_dp-(CAM0(KK+1,KK+1)*CAXX(K)+CAM0(KK+1,KK+2)*CAYX(K)&
        &                            +CAM0(KK+1,KK+3)*CAZX(K))
        CAAYY=1_dp-(CAM0(KK+2,KK+1)*CAXY(K)+CAM0(KK+2,KK+2)*CAYY(K)&
        &                            +CAM0(KK+2,KK+3)*CAZY(K))
        CAAZZ=1_dp-(CAM0(KK+3,KK+1)*CAXZ(K)+CAM0(KK+3,KK+2)*CAYZ(K)&
        &                            +CAM0(KK+3,KK+3)*CAZZ(K))
        CAAXY=-(CAM0(KK+1,KK+1)*CAXY(K)+CAM0(KK+1,KK+2)*CAYY(K)&
        &                           +CAM0(KK+1,KK+3)*CAZY(K))
        CAAYX=-(CAM0(KK+2,KK+1)*CAXX(K)+CAM0(KK+2,KK+2)*CAYX(K)&
        &                           +CAM0(KK+2,KK+3)*CAZX(K))
        CAAXZ=-(CAM0(KK+1,KK+1)*CAXZ(K)+CAM0(KK+1,KK+2)*CAYZ(K)&
        &                           +CAM0(KK+1,KK+3)*CAZZ(K))
        CAAZX=-(CAM0(KK+3,KK+1)*CAXX(K)+CAM0(KK+3,KK+2)*CAYX(K)&
        &                           +CAM0(KK+3,KK+3)*CAZX(K))
        CAAYZ=-(CAM0(KK+2,KK+1)*CAXZ(K)+CAM0(KK+2,KK+2)*CAYZ(K)&
        &                           +CAM0(KK+2,KK+3)*CAZZ(K))
        CAAZY=-(CAM0(KK+3,KK+1)*CAXY(K)+CAM0(KK+3,KK+2)*CAYY(K)&
        &                           +CAM0(KK+3,KK+3)*CAZY(K))
     
!---------------------------------------------------------------------
!
!---------- Computing the inverse of AA(K) -> B(K) -------------------
!
!---------- Calculation of the determinant ---------------------------
        CDETERM =   CAAXX * (CAAYY*CAAZZ-CAAYZ*CAAZY) &
        &          - CAAYX * (CAAXY*CAAZZ-CAAZY*CAAXZ) &
        &          + CAAZX * (CAAXY*CAAYZ-CAAYY*CAAXZ)
    
        CDETER = CUN/CDETERM
      
      
!---------------------------------------------------------------------

!----------- Matrix inversion ----------------------------------------
        CBXX=CDETER*(CAAYY*CAAZZ-CAAZY*CAAYZ)
        CBXY=-CDETER*(CAAXY*CAAZZ-CAAZY*CAAXZ)
        CBXZ=CDETER*(CAAXY*CAAYZ-CAAYY*CAAXZ)
        CBYX=-CDETER*(CAAYX*CAAZZ-CAAZX*CAAYZ)
        CBYY=CDETER*(CAAXX*CAAZZ-CAAZX*CAAXZ)
        CBYZ=-CDETER*(CAAXX*CAAYZ-CAAYX*CAAXZ)
        CBZX=CDETER*(CAAYX*CAAZY-CAAZX*CAAYY)
        CBZY=-CDETER*(CAAXX*CAAZY-CAAZX*CAAXY)
        CBZZ=CDETER*(CAAXX*CAAYY-CAAYX*CAAXY) 
      
!---------------------------------------------------------------------
!
!------------ Matrix C(K) -> Alpha(K).B(K) ---------------------------
        CXX=CAXX(K)*CBXX+CAXY(K)*CBYX+CAXZ(K)*CBZX
        CYY=CAYX(K)*CBXY+CAYY(K)*CBYY+CAYZ(K)*CBZY
        CZZ=CAZX(K)*CBXZ+CAZY(K)*CBYZ+CAZZ(K)*CBZZ
        CXY=CAXX(K)*CBXY+CAXY(K)*CBYY+CAXZ(K)*CBZY
        CYX=CAYX(K)*CBXX+CAYY(K)*CBYX+CAYZ(K)*CBZX
        CXZ=CAXX(K)*CBXZ+CAXY(K)*CBYZ+CAXZ(K)*CBZZ
        CZX=CAZX(K)*CBXX+CAZY(K)*CBYX+CAZZ(K)*CBZX
        CYZ=CAYX(K)*CBXZ+CAYY(K)*CBYZ+CAYZ(K)*CBZZ
        CZY=CAZX(K)*CBXY+CAZY(K)*CBYY+CAZZ(K)*CBZY
      
!----------------------------------------------------------------------
!
      
!$OMP DO
      DO L=1,NMAX
        LL=3*(L-1)
    !----------------- Vector WW(L) ---------------------------------------
        CWWXX(L)=CAM0(LL+1,KK+1)*CXX+CAM0(LL+1,KK+2)*CYX&
        &       +CAM0(LL+1,KK+3)*CZX
        CWWYY(L)=CAM0(LL+2,KK+1)*CXY+CAM0(LL+2,KK+2)*CYY&
        &       +CAM0(LL+2,KK+3)*CZY
        CWWZZ(L)=CAM0(LL+3,KK+1)*CXZ+CAM0(LL+3,KK+2)*CYZ&
        &       +CAM0(LL+3,KK+3)*CZZ
        CWWXY(L)=CAM0(LL+1,KK+1)*CXY+CAM0(LL+1,KK+2)*CYY&
        &       +CAM0(LL+1,KK+3)*CZY
        CWWYX(L)=CAM0(LL+2,KK+1)*CXX+CAM0(LL+2,KK+2)*CYX&
        &       +CAM0(LL+2,KK+3)*CZX
        CWWXZ(L)=CAM0(LL+1,KK+1)*CXZ+CAM0(LL+1,KK+2)*CYZ&
        &       +CAM0(LL+1,KK+3)*CZZ
        CWWZX(L)=CAM0(LL+3,KK+1)*CXX+CAM0(LL+3,KK+2)*CYX& 
        &       +CAM0(LL+3,KK+3)*CZX
        CWWYZ(L)=CAM0(LL+2,KK+1)*CXZ+CAM0(LL+2,KK+2)*CYZ&
        &       +CAM0(LL+2,KK+3)*CZZ
        CWWZY(L)=CAM0(LL+3,KK+1)*CXY+CAM0(LL+3,KK+2)*CYY&
        &       +CAM0(LL+3,KK+3)*CZY
    !------------------ Vector V(L) ---------------------------------------- 
        CVXX(L)=CAM0(KK+1,LL+1)
        CVYY(L)=CAM0(KK+2,LL+2)
        CVZZ(L)=CAM0(KK+3,LL+3)
        CVXY(L)=CAM0(KK+1,LL+2)
        CVYX(L)=CAM0(KK+2,LL+1)
        CVXZ(L)=CAM0(KK+1,LL+3)
        CVZX(L)=CAM0(KK+3,LL+1)
        CVYZ(L)=CAM0(KK+2,LL+3)
        CVZY(L)=CAM0(KK+3,LL+2)

      ENDDO
!$OMP END DO
        
      
!-----------------------------------------------------------------------
!
!************************************************************************
!*       Solving the Dyson's equation inside the molecular              *
!*                           Structure                                  *
!************************************************************************
        DO J1=1,NMAX

!$OMP DO

            DO I1=1,NMAX
                II1=3*(I1-1)
                JJ1=3*(J1-1)
                !!!!!!!!!!!!! Order changed
                CAM0(II1+1,JJ1+1)=CAM0(II1+1,JJ1+1)+&
                &   CWWXX(I1)*CVXX(J1)+CWWXY(I1)*CVYX(J1)+CWWXZ(I1)*CVZX(J1)
                CAM0(II1+2,JJ1+1)=CAM0(II1+2,JJ1+1)+&
                &   CWWYX(I1)*CVXX(J1)+CWWYY(I1)*CVYX(J1)+CWWYZ(I1)*CVZX(J1)
                CAM0(II1+3,JJ1+1)=CAM0(II1+3,JJ1+1)+&
                &   CWWZX(I1)*CVXX(J1)+CWWZY(I1)*CVYX(J1)+CWWZZ(I1)*CVZX(J1)
                CAM0(II1+1,JJ1+2)=CAM0(II1+1,JJ1+2)+&
                &   CWWXX(I1)*CVXY(J1)+CWWXY(I1)*CVYY(J1)+CWWXZ(I1)*CVZY(J1)
                CAM0(II1+2,JJ1+2)=CAM0(II1+2,JJ1+2)+&
                &   CWWYX(I1)*CVXY(J1)+CWWYY(I1)*CVYY(J1)+CWWYZ(I1)*CVZY(J1)
                CAM0(II1+3,JJ1+2)=CAM0(II1+3,JJ1+2)+&
                &   CWWZX(I1)*CVXY(J1)+CWWZY(I1)*CVYY(J1)+CWWZZ(I1)*CVZY(J1)
                CAM0(II1+1,JJ1+3)=CAM0(II1+1,JJ1+3)+&
                &   CWWXX(I1)*CVXZ(J1)+CWWXY(I1)*CVYZ(J1)+CWWXZ(I1)*CVZZ(J1)
                CAM0(II1+2,JJ1+3)=CAM0(II1+2,JJ1+3)+&
                &   CWWYX(I1)*CVXZ(J1)+CWWYY(I1)*CVYZ(J1)+CWWYZ(I1)*CVZZ(J1)
                CAM0(II1+3,JJ1+3)=CAM0(II1+3,JJ1+3)+&
                &   CWWZX(I1)*CVXZ(J1)+CWWZY(I1)*CVYZ(J1)+CWWZZ(I1)*CVZZ(J1)

            ENDDO
!$OMP END DO

        ENDDO
      ENDDO
      
!$OMP END PARALLEL
!************************************************************************
!*          End of the Dyson's sequence  --> now CAM0 is field suscept. *
!************************************************************************
!*                                                                      *
!*                                                                      *
!******************** Calc. Generalized Propagator **********************
    IF (RETURNSUSC /= 1) THEN
!$OMP PARALLEL      
      DO K=1,NMAX
!$OMP DO      
        DO L=1,NMAX
            LL=3*(L-1)
            KK=3*(K-1) 
            IF(L.EQ.K)THEN
                CAM0(LL+1,KK+1)=1+CAM0(LL+1,KK+1)*CAXX(K)+CAM0(LL+1,KK+2)*CAYX(K)&
                &       +CAM0(LL+1,KK+3)*CAZX(K)
                CAM0(LL+2,KK+1)=CAM0(LL+2,KK+1)*CAXX(K)+CAM0(LL+2,KK+2)*CAYX(K)&
                &       +CAM0(LL+2,KK+3)*CAZX(K)
                CAM0(LL+3,KK+1)=CAM0(LL+3,KK+1)*CAXX(K)+CAM0(LL+3,KK+2)*CAYX(K)&
                &       +CAM0(LL+3,KK+3)*CAZX(K)
                CAM0(LL+1,KK+2)=CAM0(LL+1,KK+1)*CAXY(K)+CAM0(LL+1,KK+2)*CAYY(K)&
                &       +CAM0(LL+1,KK+3)*CAZY(K)
                
                CAM0(LL+2,KK+2)=1+CAM0(LL+2,KK+1)*CAXY(K)+CAM0(LL+2,KK+2)*CAYY(K)&
                &       +CAM0(LL+2,KK+3)*CAZY(K)
                CAM0(LL+3,KK+2)=CAM0(LL+3,KK+1)*CAXY(K)+CAM0(LL+3,KK+2)*CAYY(K)&
                &       +CAM0(LL+3,KK+3)*CAZY(K)
                CAM0(LL+1,KK+3)=CAM0(LL+1,KK+1)*CAXZ(K)+CAM0(LL+1,KK+2)*CAYZ(K)&
                &       +CAM0(LL+1,KK+3)*CAZZ(K)
                CAM0(LL+2,KK+3)=CAM0(LL+2,KK+1)*CAXZ(K)+CAM0(LL+2,KK+2)*CAYZ(K)&
                &       +CAM0(LL+2,KK+3)*CAZZ(K)
                
                CAM0(LL+3,KK+3)=1+CAM0(LL+3,KK+1)*CAXZ(K)+CAM0(LL+3,KK+2)*CAYZ(K)&
                &       +CAM0(LL+3,KK+3)*CAZZ(K)
            ELSE
                CAM0(LL+1,KK+1)=CAM0(LL+1,KK+1)*CAXX(K)+CAM0(LL+1,KK+2)*CAYX(K)&
                &       +CAM0(LL+1,KK+3)*CAZX(K)
                CAM0(LL+2,KK+1)=CAM0(LL+2,KK+1)*CAXX(K)+CAM0(LL+2,KK+2)*CAYX(K)&
                &       +CAM0(LL+2,KK+3)*CAZX(K)
                CAM0(LL+3,KK+1)=CAM0(LL+3,KK+1)*CAXX(K)+CAM0(LL+3,KK+2)*CAYX(K)&
                &       +CAM0(LL+3,KK+3)*CAZX(K)
                
                CAM0(LL+1,KK+2)=CAM0(LL+1,KK+1)*CAXY(K)+CAM0(LL+1,KK+2)*CAYY(K)&
                &       +CAM0(LL+1,KK+3)*CAZY(K)
                CAM0(LL+2,KK+2)=CAM0(LL+2,KK+1)*CAXY(K)+CAM0(LL+2,KK+2)*CAYY(K)&
                &       +CAM0(LL+2,KK+3)*CAZY(K)
                CAM0(LL+3,KK+2)=CAM0(LL+3,KK+1)*CAXY(K)+CAM0(LL+3,KK+2)*CAYY(K)&
                &       +CAM0(LL+3,KK+3)*CAZY(K)
                
                CAM0(LL+1,KK+3)=CAM0(LL+1,KK+1)*CAXZ(K)+CAM0(LL+1,KK+2)*CAYZ(K)&
                &       +CAM0(LL+1,KK+3)*CAZZ(K)
                CAM0(LL+2,KK+3)=CAM0(LL+2,KK+1)*CAXZ(K)+CAM0(LL+2,KK+2)*CAYZ(K)&
                &       +CAM0(LL+2,KK+3)*CAZZ(K)
                CAM0(LL+3,KK+3)=CAM0(LL+3,KK+1)*CAXZ(K)+CAM0(LL+3,KK+2)*CAYZ(K)&
                &       +CAM0(LL+3,KK+3)*CAZZ(K)
            ENDIF
        ENDDO
!$OMP END DO      
      ENDDO
!$OMP END PARALLEL    
    ENDIF

!**************** REMARK: At this stage the matrix CAM0 is ***************
!***************** filled with the generalized propagator ***************

      END SUBROUTINE DYSONSEQ



      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
